/* Example: bubble sort strings in array */

/* Based on bubble.c. Uses strcmp to compare 
strings and strcpy to swap them */

#include <stdio.h>
#include <string.h>

#define NUM 7 /* number in the list */
main()
{
  int i, sorted, swaps = 0;
  char names[NUM][20] = {"Smith", "Jones", "Bloggs", "Zeppelin",
                         "Aarons", "Cameron", "Peabody"};
  char temp[20];
  
  puts("The original list of names is:");     
  for (i = 0; i < NUM; i++)
    puts(names[i]);
  
  /* Bubble sort: */
  
  do {
       for (i = 1, sorted = 1; i < NUM; i++)
       {
         if (strcmp(names[i-1], names[i]) > 0)
         {
           sorted = 0;
           strcpy(temp, names[i-1]);
           strcpy(names[i-1], names[i]);
           strcpy(names[i], temp);
           swaps++;
         }
       }
     } while (!sorted);
  
  /* Output sorted list: */
  
  puts("\nIn alphabetical order, the names are:");     
  for (i = 0; i < NUM; i++)
    puts(names[i]);
  printf("\n%i swaps were performed.\n", swaps);     
}
